<template>
  <div>
    <q-card>
      <q-card-section>
        Form Tambahan
      </q-card-section>
      <q-card-section>
        <q-btn
          :label="`Tambah ${form.judul}`"
          @click="tambahForm(index)"
          v-for="(form, index) in custom_form"
          v-bind:key="index"
        />
      </q-card-section>
    </q-card>
    <q-card
      v-for="(formTambaham, index) in form"
      v-bind:key="index"
    >
      <q-card-actions>
        <q-btn icon="delete" :label="`Hapus ${formTambaham.judul}`" @click="hapusForm(index)" color="red" />
      </q-card-actions>
      <q-card-section>
        <form-tambahan
          :itemForm="formTambaham"
          :myIndex="index"
          :komponen="formTambaham.komponen"
          @inputForm="inputForm"
        />
      </q-card-section>
    </q-card>
    <q-card>
      <q-card-actions>
        <q-btn @click="$emit('prevStep')" label="Kembali" align="left" icon="arrow_left" color="orange" />
        <q-space />
        <q-btn @click="submitProduct" label="Finish" align="right" icon="arrow_right" color="green" />
      </q-card-actions>
    </q-card>
  </div>
</template>

<script>
import FormTambahan from "components/Product/FormTambahan";
export default {
  name: 'Step3Product',
  components: {
    FormTambahan
  },
  data () {
    return {
      custom_form: null,
      formData: [],
      form: [],
      product: null
    }
  },
  mounted() {
    this.custom_form = JSON.parse(this.$attrs.custom_form)
    this.product = this.$attrs.product
    if (this.product) {
      if (this.product.custom_form) {
        this.formData = this.product.custom_form
      }
    }
  },
  methods: {
    submitProduct() {
      let formData = new FormData()
      let dataR = JSON.stringify(this.formData)
      formData.append("custom_form", dataR)
      formData.append("id_product_type", this.product.id_product_type)
      formData.append("id_category", this.product.id_category)
      formData.append("name_product", this.product.name_product)
      formData.append("desc_product", this.product.desc_product)
      formData.append("price", this.product.price)
      formData.append("starting_price", this.product.starting_price)
      formData.append("final_price", this.product.final_price)
      if (this.product.price_prone_flag) {
        formData.append("price_prone_flag", 1)
      } else {
        formData.append("price_prone_flag", 0)
      }
      formData.append("level", this.product.level)
      formData.append("id_unit_price", this.product.id_unit_price)
      this.$q.loading.show()
      this.$axios.post("api/product/information/create", formData)
        .then(sukses => {
          this.$q.loading.hide()
          this.$emit("submitProduct", sukses.data)
        })
    },
    inputForm(form, index, komponen, itemForm) {
      let dataX = {
        komponen: komponen,
        isi: form,
        judul: itemForm.judul
      }
      this.formData[index] = dataX
    },
    tambahForm(index) {
      this.form.push(this.custom_form[index])
    },
    hapusForm(index) {
      this.form.splice(index, 1)
    }
  }
}
</script>
